system = {
    CriticalErrorCheck = true,
    ErrorMessage = nil,
    Recoverable = false,
    Font = nil,
}

function system:warn(msg, name)
    name = name or "DREAM ENGINE"
    success = love.window.showMessageBox(name, msg, "warning", true)
end

function system:error(msg, rec)
    rec = rec or false
    self.Recoverable = rec
    self.CriticalErrorCheck = false
    self.ErrorMessage = msg
    love.audio.pause()
end

function system:checkVer(o)
    love.getVersion = love.getVersion or function() return 0,0,0,false end
    local major, minor, revision, codename = love.getVersion()
    local vstr = nil
    if codename ~= false then
        vstr = string.format("Version %d.%d.%d", major, minor, revision);
    else vstr = "Unknown Version" end
    local str = "Cannot Continue: Your version of LOVE2D (" .. vstr .. ") is too old. \nPlease update it."
    if (major < o[1]) or (minor < o[2]) or (revision < o[3]) then
        self:error(str)
    end
end
