--[[
This is PROPRIETARY SOFTWARE YOU CAN'T DO ANYTHING COPYRIGHT (C) ME FOREVER
--]]

--[[ 
TODO:
 - Terminal, inside a pseudo-window that can be moved around and hidden.
 - Task Manager, to get an overview of all resources.
 --- Maybe even just put this in the terminal ala "top"
 - Text System (dialogue, text options)
 - Generic Control Scheme (for customizable controls)
 - Audio Range (Audio fades in and out of a single point)
--]]

require("utils")
require("raiden")
require("bsod")
require("errors")
require("terminal")

IObj = Obj:clone() --inheritence test
function IObj:mousepress(x, y, button) end
function IObj:mouserelease(button) end

function love.load(arg)
    min_dt = 1/30 --make this an option
    next_time = love.timer.getTime()
    
    images = {}
    images.sprite = love.graphics.newImage('assets/raiden.png')
    
    audio = {}
    audio.sound = love.audio.newSource("assets/Heavy_Atmosphere.ogg")
    audio.tada = love.audio.newSource("assets/tada.ogg", "static")
    audio.sound:setLooping(true)
    audio.sound:play()
    
    fonts = {}
    fonts.Default = love.graphics.newFont("assets/lucon.ttf", 20)
    fonts.Console = love.graphics.newFont("assets/console.ttf", 17)
    love.graphics.setFont(fonts.Default)
    
    glob = {
        --Obj:new(20,100,images.sprite),
        --IObj:new(250,100,images.sprite),
    }
    
    love.keyboard.setKeyRepeat(true)
    system:checkVer({0,9,2})
end

function love.update(dt)
    next_time = next_time + min_dt
if system.CriticalErrorCheck == true then
    for i,j in pairs(glob) do
        j:update()
    end
    terminal:update(dt)
else bsod:update(dt) end
end

function love.mousepressed(x, y, button)
if system.CriticalErrorCheck == true then
    for i,j in pairs(glob) do
        j:mousepress(x, y, button)
    end
    ---[[
    if button == "r" then
        table.insert(glob, Obj:new(x-images.sprite:getWidth()/2,y-images.sprite:getHeight()/2,images.sprite))
        
        if table.getn(glob) > 10 then
            system:error("EDGY_ERROR: Too Many Raidens 0x88888888", true)
            for i,j in pairs(glob) do
                j.sound:stop()
            end
            glob = {}
        end
    end
    terminal:mousepress(x, y, button)
else end
end

function love.mousereleased(x, y, button)
if system.CriticalErrorCheck == true then
    for i,j in pairs(glob) do
        j:mouserelease(button)
    end
    terminal:mouserelease(x, y, button)
else end
end

function love.textinput(t)
if system.CriticalErrorCheck == true then
    terminal:textinput(t)
else end
end

function love.keypressed(key)
if system.CriticalErrorCheck == true then
    --[[
    if key=="e" then
        --system:warn("oops")
        system:error("MAMMAL_ERROR: Shall we walk though the rainy plains of Spain? \nSANITY CHECK: Pi is... Pi is... About 3.", true)
    end --]]
    
    terminal:keyboard(key)
else bsod:exitkey(key) end
end

function love.draw(dt)
    local w, h = love.window.getDimensions()
if system.CriticalErrorCheck == true then
    --don't forget, how things are ordered in this functions are how they get rendered
    
    love.graphics.setColor(800, 50, 100, 255)
    love.graphics.rectangle('fill', 0, 0, w, h)
    love.graphics.reset()
    love.graphics.setFont(fonts.Default)
    --love.graphics.print("you know what fuck this war\ni just want you dead", 300, 100)
    
    for i,j in pairs(glob) do
        love.graphics.draw(j.img, j.x, j.y)
    end
    
    terminal:spawn()
    --FPS always renders last so it's over everything.
    love.graphics.setFont(fonts.Console)
    love.graphics.print("FPS:"..tostring(love.timer.getFPS( )), 10, 10)
    love.graphics.reset()
else bsod:screen(system.ErrorMessage) end
    --timing logic
    local cur_time = love.timer.getTime()
    if next_time <= cur_time then
        next_time = cur_time
        return
    end
    love.timer.sleep(next_time - cur_time)
end

