Obj = {
    x = 100,
    y = 100,
    img = nil,
    width = 100,
    height = 100,
    dragging = { active = false, diffX = 0, diffY = 0 },
    sound = nil,
}

--metaObj = metaObj or {}

function Obj:update()
    if self.dragging.active then
        self.x = love.mouse.getX() - self.dragging.diffX
        self.y = love.mouse.getY() - self.dragging.diffY
    end
end

function Obj:mousepress(x, y, button)
    if button == "l"
    and x > self.x and x < self.x + self.width
    and y > self.y and y < self.y + self.height
    then
        self.dragging.active = true
        self.dragging.diffX = x - self.x
        self.dragging.diffY = y - self.y
    end
end

function Obj:mouserelease(button)
    if button == "l" then self.dragging.active = false end
end

function Obj:move(x, y)
    self.x = x
    self.y = y
end

function Obj:init(x, y, img, o)
    o.img = img
    o.x = x
    o.y = y
    o.width = img:getWidth()
    o.height = img:getHeight()
    o.sound = love.audio.newSource("assets/tada.ogg", "static")
    o.sound:play()
    return o
end

function Obj:new(x, y, img)
    return Obj:init(x, y, img, table.copy(Obj))
end

function Obj:clone()
    local t = table.copy(Obj)
    function t:new(x, y, img) return t:init(x, y, img, table.copy(t)) end
    return t
end
